Bug 201313 - CVE-2006-3459 kfax affected by libtiff flaws (CVE-2006-3460 CVE-2006-3461 CVE-2006-3462 CVE-2006-3463 CVE-2006-3464 CVE-2006-3465)
CVE-2006-3459 kfax affected by libtiff flaws (CVE-2006-3460 CVE-2006-3461 CVE...
Product: Red Hat Enterprise Linux 2.1
Classification: Red Hat
Component: kdegraphics (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ngo Than
: Security
Depends On:
  Show dependency treegraph
Reported: 2006-08-04 06:04 EDT by Mark J. Cox (Product Security)
Modified: 2007-11-30 17:06 EST (History)
2 users (show)

See Also:
Fixed In Version: RHSA-2006-0648
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2006-08-28 07:56:09 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Mark J. Cox (Product Security) 2006-08-04 06:04:31 EDT
+++ This bug was initially created as a clone of Bug #199111 +++

From: Tavis Ormandy <taviso@google.com>
(with edits from Mark Cox)

Hi there, Google have sponsored me to perform a security audit of
libtiff-3.8.2, in which a number  of critical security flaws have been
uncovered. These flaws could be leveraged by an attacker to compromise
or disrupt any services that support the processing of tiff images.

Several buffer overflows have been discovered, including a stack
buffer overflow via TIFFFetchShortPair() in tif_dirread.c, which is
used to read two unsigned shorts from the input file. While a bounds
check is performed via CheckDirCount(), no action is taken on the
result allowing a pathological tdir_count to read an arbitrary number
of unsigned shorts onto a stack buffer. Exploitation of this error is
trivial, a tiff file with a pathological 'DotRange' (0x0150),
'YCbCrSubsampling' (0x0212), 'HalftoneHints' (0x0141) or 'PageNumber'
(0x0129) tag can be used to execute arbitrary code with the privileges
of the application using libtiff. (CVE-2006-3459)

A heap overflow vulnerability was discovered in the jpeg decoder,
where TIFFScanLineSize() is documented to return the size in bytes
that a subsequent call to TIFFReadScanline() would write, however the
encoded jpeg stream may disagree with these results and overrun the
buffer with more data than expected (tiff_jpeg.c ~725). A sanity check
is performed and prints a warning, however execution is permitted to
continue (presumbaly to permit truncated datastreams).  (CVE-2006-3460)

Another heap overflow exists in the PixarLog decoder where a run
length encoded data stream may specify a stride that is not an exact
multiple of the number of samples. The result is that on the final
decode operation the destination buffer is overrun, potentially
allowing an attacker to execute arbitrary code. (CVE-2006-3461)

The NeXT RLE decoder was also vulnerable to a heap overflow
vulnerability, where no bounds checking was performed on the result of
certain RLE decoding operations. This was solved by ensuring the
number of pixels written did not exceed the size of the scanline
buffer already prepared. (CVE-2006-3462)

An infinite loop was discovered in EstimateStripByteCounts(), where a
16bit unsigned short was used to iterate over a 32bit unsigned value,
should the unsigned int (td_nstrips) have exceeded USHORT_MAX, the
loop would never terminate and continue forever. This could have been
leveraged as a particularly effective DoS attack. The flaw was
corrected by widening the loop iterator to 32 bits.  (CVE-2006-3463)

Multiple unchecked arithmetic operations were uncovered, including a
number of the range checking operations deisgned to ensure the offsets
specified in tiff directories are legitimate. These  can be caused to
wrap for extreme values, bypassing sanity checks. (CVE-2006-3464)

Additionally, a number of codepaths were uncovered where assertions did not hold
true, resulting in the client application calling abort().

A flaw was also uncovered in libtiffs custom tag support, as
documented here http://www.libtiff.org/v3.6.0.html. While well formed
tiff files must have correctly ordered directories, libtiff attempts
to support broken images that do not. However in certain
circumstances, creating anonymous fields prior to merging field
information from codec information can result in recognised fields
with unexpected values. This state results in abnormal behaviour,
crashes, or potentially arbitrary code execution. It is likely the
tiff maintainers may implement a different fix to my solution, I have
decided to disregard all unknown directories encoutered prior to
finding a 'Compression' tag.  (CVE-2006-3465)

Testcases have been created to demonstrate some of these bugs, the
file tiff-testcases.tgz.gpg attached to this mail includes an INDEX
file that describes the bug.

See original bz for patch
Comment 1 Ngo Than 2006-08-17 11:26:28 EDT
it's fixed in kdegraphics-2.2.2-4.4 (RHEL2.1) and kdegraphics-3.1.3-3.9 
Comment 3 Red Hat Bugzilla 2006-08-28 07:56:10 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.


Note You need to log in before you can comment on or make changes to this bug.